<template>
  <v-app>
    <!--v-app-bar hide-on-scroll dense app color="primary" dark>
      <div class="d-flex align-center">
        <span>Group Flight</span>
      </div>

      <v-spacer></v-spacer>
    </v-app-bar-->

    <v-main>
      <v-stepper v-model="step">
        <v-stepper-header>
          <v-stepper-step :complete="step > 1" step="1"
            >Choose Airports</v-stepper-step
          >
          <v-divider></v-divider>
          <v-stepper-step :complete="step > 2" step="2"
            >Choose dates</v-stepper-step
          >
          <v-divider></v-divider>
          <v-stepper-step step="3">Results</v-stepper-step>
        </v-stepper-header>

        <v-stepper-items>
          <v-stepper-content step="1">
            <div class="container">
              <Airports />
              <Map />
            </div>

            <div class="d-flex pa-2">
              <v-spacer />
              <v-btn color="primary" :disabled="noAirport" @click="step = 2">
                Continue
              </v-btn>
            </div>
          </v-stepper-content>
          <v-stepper-content step="2">
            <div style="height: calc(100vh - 150px);">
              <DateRange />
            </div>
            <div class="d-flex pa-2">
              <v-btn color="secondary" @click="step = 1">
                Previous
              </v-btn>
              <v-spacer></v-spacer>

              <v-btn color="primary" @click="displayResults">
                Continue
              </v-btn>
            </div>
          </v-stepper-content>

          <v-stepper-content step="3">
            <div style="height: calc(100vh - 150px);">
              <Results />
            </div>
            <div class="d-flex pa-2">
              <v-btn color="secondary" @click="step = 2">
                Previous
              </v-btn>
              <v-spacer></v-spacer>
            </div>
          </v-stepper-content>
        </v-stepper-items>
      </v-stepper>
    </v-main>
    <Footer style="display:none;" />
  </v-app>
</template>

<script>
import Airports from "./components/Airports";
import Map from "./components/Map";
import DateRange from "./components/DateRange";
import Results from "./components/Results";
import Footer from "./components/Footer";

export default {
  name: "App",

  components: {
    Airports,
    Map,
    DateRange,
    Results,
    Footer,
  },

  computed: {
    step: {
      get() {
        return this.$store.getters.getStep;
      },
      set(value) {
        this.$store.dispatch("setStep", value);
      },
    },
    choosenAirports: {
      get() {
        return this.$store.getters.getChoosenAirports;
      },
    },
    noAirport() {
      return this.choosenAirports.length == 0;
    },
  },
  methods: {
    displayResults() {
      this.step = 3;
      this.$store.dispatch("calculatePrices");
    },
  },
};
</script>

<style>
.container {
  height: calc(100vh - 150px);
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(250px, 1fr));
  grid-gap: 10px;
}
.v-stepper__content {
  height: calc(100vh - 72px);
}
</style>
